      subroutine main
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER LINE*80
      DIMENSION EXPDAT_RE(2),EXPDAT_IM(2)
      COMPLEX*16 GAMMA(2),ZTMP1,ZTMP2
      DIMENSION RTMP1(2),RTMP2(2)
      EQUIVALENCE (ZTMP1,RTMP1(1)),(ZTMP2,RTMP2(1))
      PI=ATAN2(0.0,-1.0)
      PHSUM=0
      WSUM=0
      NIT=0
      AVGPHA=0
      OPEN ( UNIT=5,FILE='dutz.txt',STATUS='OLD')
    8 READ(5,520) LINE
      IF(LINE(1:3).EQ.'end') GOTO 30
      READ(LINE(8:80),*)
     &EXPDAT_RE(1),EXPDAT_IM(1),
     &EXPDAT_RE(2),EXPDAT_IM(2)
C Convert the complex impedances to reflection coefficient.
      DO 11 K=1,2 
      RTMP1(1)=EXPDAT_RE(K)-50
      RTMP1(2)=EXPDAT_IM(K)
      RTMP2(1)=EXPDAT_RE(K)+50
      RTMP2(2)=EXPDAT_IM(K)
      GAMMA(K)=ZTMP1/ZTMP2
   11 CONTINUE
C Convert voltage reflection coefficients GAMMA to amplitude and phase
      ZTMP1=GAMMA(1)
      ZTMP2=GAMMA(2)
      T=DABS(RTMP1(2)*RTMP2(2))
      PD=RTMP1(2)-RTMP2(2)
      DO 21 K=1,2 
      ZTMP1=GAMMA(K)
      AMPL=DSQRT(RTMP1(1)*RTMP1(1)+RTMP1(2)*RTMP1(2))
      PHASE=180*ATAN2(RTMP1(2),RTMP1(1))/PI
      RTMP1(1)=AMPL
      IF(K.EQ.1)PHASE=PHASE-AVGPHA
      RTMP1(2)=PHASE
      GAMMA(K)=ZTMP1
   21 CONTINUE
      IF(T.LT.0.01)GOTO 25
      ZTMP1=GAMMA(1)
      ZTMP2=GAMMA(2)
      PD=RTMP1(2)-RTMP2(2)
      PHSUM=PHSUM+T*PD
      WSUM=WSUM+T
   25 WRITE(*,610)LINE(1:8),GAMMA(1),GAMMA(2),GAMMA(1)-GAMMA(2),T
      GOTO 8
   30 CONTINUE
      NIT=NIT+1
      AVGPHA=PHSUM/WSUM
      IF(NIT.EQ.1)PHDIFF=AVGPHA
      WRITE(*,*)'AVG PHASE DIFF',AVGPHA
      REWIND 5
      PHSUM=0
      WSUM=0
      IF(NIT.LT.2)GOTO 8
      rewind 5
C Convert back to impedances
  108 READ(5,520) LINE
      IF(LINE(1:3).EQ.'end') GOTO 40
      READ(LINE(8:80),*)
     &EXPDAT_RE(1),EXPDAT_IM(1),
     &EXPDAT_RE(2),EXPDAT_IM(2)
C Convert the old complex impedances to reflection coefficients.
      RTMP1(1)=EXPDAT_RE(1)-50
      RTMP1(2)=EXPDAT_IM(1)
      RTMP2(1)=EXPDAT_RE(1)+50
      RTMP2(2)=EXPDAT_IM(1)
      GAMMA(1)=ZTMP1/ZTMP2
      ZTMP1=GAMMA(1)
      AMPL=DSQRT(RTMP1(1)*RTMP1(1)+RTMP1(2)*RTMP1(2))
      PHASE=180*ATAN2(RTMP1(2),RTMP1(1))/PI
      PHASE=PHASE-PHDIFF
      PHASE=PI*PHASE/180
      RTMP1(1)=AMPL*COS(PHASE)
      RTMP1(2)=AMPL*SIN(PHASE)
      GAMMA(1)=ZTMP1
      ZTMP2=-50*(ZTMP1+1)/(ZTMP1-1)
      RTMP1(1)=EXPDAT_RE(2)
      RTMP1(2)=EXPDAT_IM(2)
      WRITE(*,610)LINE(1:8),ZTMP2,ZTMP1,ZTMP2-ZTMP1
      GOTO 108
   40 CONTINUE      
      WRITE(*,620)PHDIFF
      STOP      
  520 FORMAT(80A)
  610 FORMAT(A,3('(',F8.5,F8.2,')  '),F8.4)      
  620 FORMAT('	Applied phase shift=',F5.1,' degrees')
      END
